#include <cassert>
#include <chrono>
#include <cmath>
#include <iostream>
#include <thread>

#include <coyote.hpp>

using namespace coyote;

int main() {
    Coyote coyote("test_simple");

    coyote.def_grid({{4}}, {{0.0, 0.0, 1.0, 1.0}}, {{0.0, 1.0, 1.0, 0.0}}, {{0, 1, 2, 3}});

    double i = 1.0;
    coyote.add_field(
        "simple_source",
        "simple_grid",
        "clock",
        [&](Event ev) {
            using namespace std::chrono_literals;
            std::cout << i << "==" << ev.data()[0] << std::endl;
            assert(fabs(i - ev.data()[0]) / i < 1e-10);
            ev.release(); // We dont need the buffer here anymore
            i += 2;
            std::this_thread::sleep_for(10ms); // simulate workload
        },
        "PT2S",
        1);

    coyote_run();
    return 0;
}
